#!/usr/bin/env sh
#
#  No arguments install in "html" directory.
# ./createhtml.sh /install/directory
#

if !(test -r $XML_CATALOG_FILES && test -r $SGML_CATALOG_FILES); then
    echo "ERROR:  Missing Catalog file(s)";
    echo "XML_CATALOG_FILES:  $XML_CATALOG_FILES"
    echo "SGML_CATALOG_FILES: $SGML_CATALOG_FILES"
    exit
fi
if [ $# = 0 ]; then
    INSTALLDIR=html
elif [ $# != 1 ]; then
    echo "ERROR: Expecting the install directory as the sole parameter"
    exit
else
    INSTALLDIR=$1
fi

if !(test -r $INSTALLDIR); then
    echo "ERROR:  Please create the install directory"
    exit
fi

DIR=$PWD
# inline includes w/xmllint
# also replace ../../ with ../ (slashdot nightmare!)
#xmllint --noent --loaddtd --xinclude $DIR/tutorial.dbk | \
xmllint --xinclude $DIR/tutorial.dbk | \
  sed 's/\.\.\/\.\.\//\.\.\//g' \
  > /tmp/tutorial-xinc.dbk
# generate html with docbook2html
export SP_ENCODING=XML
printf "Generating html in $INSTALLDIR ..\n"
( cd $INSTALLDIR && /bin/rm -f *.html && docbook2html $DOCBOOKARGS /tmp/tutorial-xinc.dbk )
# get rid of temp file
#/bin/rm -f /tmp/tutorial-xinc.dbk
#
printf "Done. Point browser at $INSTALLDIR/index.html\n"
