############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import ZSI
from ZSI.wstools.Namespaces import GLOBUS

from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHomeManager import ResourceHomeManager
from pyGridWare.addressing.AddressingUtils import AddressingUtils
#from pyGridWare.resource.ResourceContext import ResourceContext
#from pyGridWare.resource.ResourceHome import SimpleResourceHome


class Key(str):
    """Context Key that will work with Globus Client.
    """
    typecode = ZSI.TC.String(pname=(GLOBUS.CORE,"SecureContextKey"))


class ManagerHome(ResourceHomeManager, Singleton):
    def getResourceContext(self, ps, address, **kw):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key, **kw)


#class CounterPortTypeContext(ResourceContext):
#    def __init__(self, properties_class=CounterPortType):
#        ResourceContext.__init__(self, properties_class)
#
#    def setResourceID(self, resourceID):
#        ResourceContext.setResourceID(self, Key(resourceID))
#CounterPortTypeContext.home = ManagerHome.getInstance(SimpleResourceHome)